### Class

# Gio DBusObjectManagerServer

since: 2.30

#### Description

    class Gio.DBusObjectManagerServer : GObject.Object
      implements Gio.DBusObjectManager {
      /* No available fields */
    }

`GDBusObjectManagerServer` is used to export `GDBusObject` instances using the standardized `org.freedesktop.DBus.ObjectManager` interface. For example, remote D-Bus clients can get all objects and properties in a single call. Additionally, any change in the object hierarchy is broadcast using signals. This means that D-Bus clients can keep caches up to date by only listening to D-Bus signals.

The recommended path to export an object manager at is the path form of the well-known name of a D-Bus service, or below. For example, if a D-Bus service is available at the well-known name `net.example.ExampleService1`, the object manager should typically be exported at `/net/example/ExampleService1`, or below (to allow for multiple object managers in a service).

It is supported, but not recommended, to export an object manager at the root path, `/`.

See `GDBusObjectManagerClient` for the client-side code that is intended to be used with `GDBusObjectManagerServer` or any D-Bus object implementing the `org.freedesktop.DBus.ObjectManager` interface.

Available since: 2.30

#### Ancestors

- GObject

#### Implements

- GDBusObjectManager

#### Constructors

###### g_dbus_object_manager_server_new

Creates a new `GDBusObjectManagerServer` object.

since: 2.30

#### Instance methods

###### g_dbus_object_manager_server_export

Exports `object` on `manager`.

since: 2.30

###### g_dbus_object_manager_server_export_uniquely

Like `g_dbus_object_manager_server_export()` but appends a string of the form _N (with N being a natural number) to `object`‘s object path if an object with the given path already exists. As such, the `GDBusObjectProxy:g-object-path` property of `object` may be modified.

since: 2.30

###### g_dbus_object_manager_server_get_connection

Gets the `GDBusConnection` used by `manager`.

since: 2.30

###### g_dbus_object_manager_server_is_exported

Returns whether `object` is currently exported on `manager`.

since: 2.34

###### g_dbus_object_manager_server_set_connection

Exports all objects managed by `manager` on `connection`. If `connection` is `NULL`, stops exporting objects.

###### g_dbus_object_manager_server_unexport

If `manager` has an object at `path`, removes the object. Otherwise does nothing.

since: 2.30

##### Methods inherited from GObject (43)

Please see GObject for a full list of methods.

##### Methods inherited from GDBusObjectManager (4)

###### g_dbus_object_manager_get_interface

Gets the interface proxy for `interface_name` at `object_path`, if any.

since: 2.30

###### g_dbus_object_manager_get_object

Gets the `GDBusObject` at `object_path`, if any.

since: 2.30

###### g_dbus_object_manager_get_object_path

Gets the object path that `manager` is for.

since: 2.30

###### g_dbus_object_manager_get_objects

Gets all `GDBusObject` objects known to `manager`.

since: 2.30

#### Properties

###### Gio.DBusObjectManagerServer:connection

The `GDBusConnection` to export objects on.

since: 2.30

###### Gio.DBusObjectManagerServer:object-path

The object path to register the manager object at.

since: 2.30

#### Signals

##### Signals inherited from GObject (1)

###### GObject::notify

The notify signal is emitted on an object when one of its properties has its value set through g_object_set_property(), g_object_set(), et al.

##### Signals inherited from GDBusObjectManager (4)

###### GDBusObjectManager::interface-added

Emitted when `interface` is added to `object`.

since: 2.30

###### GDBusObjectManager::interface-removed

Emitted when `interface` has been removed from `object`.

since: 2.30

###### GDBusObjectManager::object-added

Emitted when `object` is added to `manager`.

since: 2.30

###### GDBusObjectManager::object-removed

Emitted when `object` is removed from `manager`.

since: 2.30

#### Class structure

    struct GioDBusObjectManagerServerClass {
      GObjectClass parent_class;

    }

Class structure for `GDBusObjectManagerServer`.

###### Class members

`parent_class: GObjectClass`

  The parent class.